#include "zcommon.acs"
#library "RANDMUS"

#include "commonFuncs.h" // Even in making a silly music randomizer mod, I require ijon's funcs.

#define RANDOMMUS 314

int MusicRandomizerOn;
int MusicInfo;

int RandMusList[RANDOMMUS] = 
{
	"D_D1_11", // The Ultimate Doom
	"D_D1_12",
	"D_D1_13",
	"D_D1_14",
	"D_D1_15",
	"D_D1_16",
	"D_D1_17",
	"D_D1_18",
	"D_D1_19",
	"D_D1_21",
	"D_D1_22",
	"D_D1_23",
	"D_D1_24",
	"D_D1_26",
	"D_D1_27",
	"D_D1_28",
	"D_D1_31",
	"D_D1_32",
	"D_D1_33",
	"D_D1_38",
	"D_VICTOR",
	"D_D2_01", 	// Doom 2
	"D_D2_02",
	"D_D2_03",
	"D_D2_04",
	"D_D2_05",
	"D_D2_06",
	"D_D2_07",
	"D_D2_08",
	"D_D2_09",
	"D_D2_10",
	"D_D2_18",
	"D_D2_20",
	"D_D2_23",
	"D_D2_25",
	"D_D2_28",
	"D_D2_30",
	"D_D2_31",
	"D_D2_32",
	"D_D2_VIC",
	"STALKER", // Duke Nukem 3D
	"DETHTOLL",
	"STREETS",
	"WATRWLD1",
	"SNAKE1",
	"THECALL",
	"AHGEEZ",
	"FUTURMIL",
	"STORM",
	"GUTWRNCH",
	"ROBOCREP",
	"STALAG",
	"PIZZED",
	"ALIENZ",
	"XPLASMA",
	"ALFREDH",
	"GLOOMY",
	"INTENTS",
	"INHIDING",
	"FATCMDR",
	"NAMES",
	"SUBWAY",
	"INVADER",
	"GOTHAM",
	"233C",
	"LORDOFLA",
	"URBAN",
	"SPOOK",
	"WHOMP",
	"MISSIMP",
	"PREPD",
	"BAKEDGDS",
	"CF",
	"LEMCHILL",
	"POB",
	"WAREHAUS",
	"LAYERS",
	"FLOGHORN",
	"DEPART",
	"RESTRICT",
	"CORNER", // Wolfenstein 3D
	"DUNGEON",
	"FUNKYOU",
	"GETTHEM",
	"GOINGAFT",
	"HEADACHE",
	"HITLWITZ",
	"NAZIRAP",
	"POW",
	"PREGNANT",
	"SEARCHIN",
	"SUSPENSE",
	"TWELFTH",
	"WARMARCH",
	"ZEROHOUR",
	"XDEATH", // Spear of Destiny
	"XFUNKIE",
	"XGETYOU",
	"XJAZNAZI",
	"XPUTIT",
	"XTIPTOE",
	"XTOWER2",
	"D_TNT_01", // TNT Evilution
	"D_TNT_02",
	"D_TNT_04",
	"D_TNT_05",
	"D_TNT_06",
	"D_TNT_07",
	"D_TNT_08",
	"D_TNT_10",
	"D_TNT_11",
	"D_TNT_14",
	"D_TNT_16",
	"D_TNT_20",
	"D_TNT_22",
	"D_TNT_31",
	"F_ADRIAN", // Freedoom Project
	"F_AMPIE",
	"F_BETWEE",
	"F_COUNT2",
	"F_COUNTD",
	"F_DDTBL2",
	"F_DDTBL3",
	"F_DDTBLU",
	"F_DEAD",
	"F_DEAD2",
	"F_DM2INT",
	"F_DM2TTL",
	"F_DOOM",
	"F_DOOM2",
	"F_E1M1",
	"F_E1M2",
	"F_E1M3",
	"F_E1M4",
	"F_E1M5",
	"F_E1M6",
	"F_E1M7",
	"F_E1M8",
	"F_E1M9",
	"F_E2M1",
	"F_E2M2",
	"F_E2M3",
	"F_E2M4",
	"F_E2M5",
	"F_E2M8",
	"F_E2M9",
	"F_EVIL",
	"F_INTER",
	"F_INTRO",
	"F_IN_CIT",
	"F_MESSAG",
	"F_MESSG2",
	"F_OPENIN",
	"F_REAF_M",
	"F_ROMER2",
	"F_ROMERO",
	"F_RUNNI2",
	"F_RUNNIN",
	"F_SHAWN",
	"F_SHAWN2",
	"F_STALKS",
	"F_STLKS2",
	"F_STLKS3",
	"F_TENSE",
	"F_THEDA2",
	"F_THEDA3",
	"F_THE_DA",
	"F_ULTIMA",
	"F_VICTOR",
	"D_H_E1M1", // Heretic
	"D_H_E1M2",
	"D_H_E1M3",
	"D_H_E1M4",
	"D_H_E1M5",
	"D_H_E1M6",
	"D_H_E1M7",
	"D_H_E1M8",
	"D_H_E1M9",
	"D_H_E2M1",
	"D_H_E2M2",
	"D_H_E2M3",
	"D_H_E2M4",
	"D_H_E2M6",
	"D_H_E2M7",
	"D_H_E2M8",
	"D_H_E2M9",
	"D_H_E3M2",
	"D_H_E3M3",
	"D_H_CPTD",
	"WINNOWR", // Hexen
	"JACHR",
	"SIMONR",
	"WUTZITR",
	"FALCONR",
	"LEVELR",
	"CRYPTR",
	"SWAMPR",
	"DEEPR",
	"FUBASR",
	"GROVER",
	"FORTR",
	"VOIDR",
	"CHAP_1R",
	"CHAP_2R",
	"CHAP_3R",
	"CHAP_4R",
	"SECRETR",
	"CHIPPYR",
	"PERCR",
	"FOOJAR",
	"SIXATER",
	"WOBABYR",
	"FANTAR",
	"BLECHR",
	"BONESR",
	"OCTOR",
	"RITHMR",
	"STALKR",
	"BORKR",
	"CRUCIBR",
	"CHARTR",
	"HUB",
	"HALL",
	"ORB",
	"CHESS",
	"CASA1", // Hexen 2
	"CASA2",
	"CASA3",
	"CASA4",
	"EGYP1",
	"EGYP2",
	"EGYP3",
	"MESO1",
	"MESO2",
	"MESO3",
	"ROMA1",
	"ROMA2",
	"ROMA3",
	"CASB1",
	"CASB2",
	"CASB3",
	"TULKU1", // Hexen 2 Expansion
	"TULKU2",
	"TULKU3",
	"TULKU4",
	"TULKU5",
	"TULKU6",
	"TULKU7",
	"TULKU8",
	"TULKU9",
	"TULKU10",
	"CCCOOL", // ROTT
	"CHANT",
	"EVINRUDE",
	"EXCALIBR",
	"FASTWAY",
	"GAZZ",
	"HELLERO",
	"HOWDIDO",
	"KISSOFF",
	"MEDIEV1A",
	"MISTACHE",
	"OWW",
	"RADAGIO",
	"RISE",
	"RUNLIKE",
	"SHARDS",
	"SMOKE",
	"SMOOTH",
	"SPRAY",
	"STAIRS",
	"SUCKTHIS",
	"TASKFORC",
	"WATZNEXT",
	"WHERIZIT",
	"WORK_DAY",
	"YOUSUCK",
	"D_C_E1M1", // Chex Quest
	"D_C_E1M2",
	"D_C_E1M3",
	"D_C_E1M4",
	"D_C_E1M5",
	"D_C_E2M1",
	"D_C_E2M2",
	"D_C_E2M3",
	"D_C_E2M4",
	"D_C_E2M5",
	"D_C_E3M1",
	"D_C_E3M2",
	"D_C_E3M3",
	"D_C_E3M4",
	"D_C_E3M5",
	"D_C_INTR",
	"D_C_VICT",
	"D_C_BUNN",
	"S_ACTION", // Strife
	"S_CASTLE",
	"S_DANGER",
	"S_DARK",
	"S_DARKER",
	"S_DRONE",
	"S_FAST",
	"S_FIGHT",
	"S_INSTRY",
	"S_MARCH",
	"S_MOOD",
	"S_PANTHR",
	"S_SAD",
	"S_SLIDE",
	"S_SPENSE",
	"S_STRIKE",
	"S_TECH",
	"S_TRIBAL",
	"S_MAP03"
};

int RandMusInfo[RANDOMMUS] = 
{
	"DESC_D_D1_11", // The Ultimate Doom
	"DESC_D_D1_12",
	"DESC_D_D1_13",
	"DESC_D_D1_14",
	"DESC_D_D1_15",
	"DESC_D_D1_16",
	"DESC_D_D1_17",
	"DESC_D_D1_18",
	"DESC_D_D1_19",
	"DESC_D_D1_21",
	"DESC_D_D1_22",
	"DESC_D_D1_23",
	"DESC_D_D1_24",
	"DESC_D_D1_26",
	"DESC_D_D1_27",
	"DESC_D_D1_28",
	"DESC_D_D1_31",
	"DESC_D_D1_32",
	"DESC_D_D1_33",
	"DESC_D_D1_38",
	"DESC_D_VICTOR",
	"DESC_D_D2_01",  // Doom 2
	"DESC_D_D2_02",
	"DESC_D_D2_03",
	"DESC_D_D2_04",
	"DESC_D_D2_05",
	"DESC_D_D2_06",
	"DESC_D_D2_07",
	"DESC_D_D2_08",
	"DESC_D_D2_09",
	"DESC_D_D2_10",
	"DESC_D_D2_18",
	"DESC_D_D2_20",
	"DESC_D_D2_23",
	"DESC_D_D2_25",
	"DESC_D_D2_28",
	"DESC_D_D2_30",
	"DESC_D_D2_31",
	"DESC_D_D2_32",
	"DESC_D_D2_VIC",
	"DESC_STALKER", // Duke Nukem 3D
	"DESC_DETHTOLL",
	"DESC_STREETS",
	"DESC_WATRWLD1",
	"DESC_SNAKE1",
	"DESC_THECALL",
	"DESC_AHGEEZ",
	"DESC_FUTURMIL",
	"DESC_STORM",
	"DESC_GUTWRNCH",
	"DESC_ROBOCREP",
	"DESC_STALAG",
	"DESC_PIZZED",
	"DESC_ALIENZ",
	"DESC_XPLASMA",
	"DESC_ALFREDH",
	"DESC_GLOOMY",
	"DESC_INTENTS",
	"DESC_INHIDING",
	"DESC_FATCMDR",
	"DESC_NAMES",
	"DESC_SUBWAY",
	"DESC_INVADER",
	"DESC_GOTHAM",
	"DESC_233C",
	"DESC_LORDOFLA",
	"DESC_URBAN",
	"DESC_SPOOK",
	"DESC_WHOMP",
	"DESC_MISSIMP",
	"DESC_PREPD",
	"DESC_BAKEDGDS",
	"DESC_CF",
	"DESC_LEMCHILL",
	"DESC_POB",
	"DESC_WAREHAUS",
	"DESC_LAYERS",
	"DESC_FLOGHORN",
	"DESC_DEPART",
	"DESC_RESTRICT",
	"DESC_CORNER", // Wolfenstein 3D
	"DESC_DUNGEON",
	"DESC_FUNKYOU",
	"DESC_GETTHEM",
	"DESC_GOINGAFT",
	"DESC_HEADACHE",
	"DESC_HITLWITZ",
	"DESC_NAZIRAP",
	"DESC_POW",
	"DESC_PREGNANT",
	"DESC_SEARCHIN",
	"DESC_SUSPENSE",
	"DESC_TWELFTH",
	"DESC_WARMARCH",
	"DESC_ZEROHOUR",
	"DESC_XDEATH", // Spear of Destiny
	"DESC_XFUNKIE",
	"DESC_XGETYOU",
	"DESC_XJAZNAZI",
	"DESC_XPUTIT",
	"DESC_XTIPTOE",
	"DESC_XTOWER2",
	"DESC_D_TNT_01", // TNT Evilution
	"DESC_D_TNT_02",
	"DESC_D_TNT_04",
	"DESC_D_TNT_05",
	"DESC_D_TNT_06",
	"DESC_D_TNT_07",
	"DESC_D_TNT_08",
	"DESC_D_TNT_10",
	"DESC_D_TNT_11",
	"DESC_D_TNT_14",
	"DESC_D_TNT_16",
	"DESC_D_TNT_20",
	"DESC_D_TNT_22",
	"DESC_D_TNT_31",
	"DESC_F_ADRIAN", // Freedoom Project
	"DESC_F_AMPIE",
	"DESC_F_BETWEE",
	"DESC_F_COUNT2",
	"DESC_F_COUNTD",
	"DESC_F_DDTBL2",
	"DESC_F_DDTBL3",
	"DESC_F_DDTBLU",
	"DESC_F_DEAD",
	"DESC_F_DEAD2",
	"DESC_F_DM2INT",
	"DESC_F_DM2TTL",
	"DESC_F_DOOM",
	"DESC_F_DOOM2",
	"DESC_F_E1M1",
	"DESC_F_E1M2",
	"DESC_F_E1M3",
	"DESC_F_E1M4",
	"DESC_F_E1M5",
	"DESC_F_E1M6",
	"DESC_F_E1M7",
	"DESC_F_E1M8",
	"DESC_F_E1M9",
	"DESC_F_E2M1",
	"DESC_F_E2M2",
	"DESC_F_E2M3",
	"DESC_F_E2M4",
	"DESC_F_E2M5",
	"DESC_F_E2M8",
	"DESC_F_E2M9",
	"DESC_F_EVIL",
	"DESC_F_INTER",
	"DESC_F_INTRO",
	"DESC_F_IN_CIT",
	"DESC_F_MESSAG",
	"DESC_F_MESSG2",
	"DESC_F_OPENIN",
	"DESC_F_REAF_M",
	"DESC_F_ROMER2",
	"DESC_F_ROMERO",
	"DESC_F_RUNNI2",
	"DESC_F_RUNNIN",
	"DESC_F_SHAWN",
	"DESC_F_SHAWN2",
	"DESC_F_STALKS",
	"DESC_F_STLKS2",
	"DESC_F_STLKS3",
	"DESC_F_TENSE",
	"DESC_F_THEDA2",
	"DESC_F_THEDA3",
	"DESC_F_THE_DA",
	"DESC_F_ULTIMA",
	"DESC_F_VICTOR",
	"DESC_D_H_E1M1", // Heretic
	"DESC_D_H_E1M2",
	"DESC_D_H_E1M3",
	"DESC_D_H_E1M4",
	"DESC_D_H_E1M5",
	"DESC_D_H_E1M6",
	"DESC_D_H_E1M7",
	"DESC_D_H_E1M8",
	"DESC_D_H_E1M9",
	"DESC_D_H_E2M1",
	"DESC_D_H_E2M2",
	"DESC_D_H_E2M3",
	"DESC_D_H_E2M4",
	"DESC_D_H_E2M6",
	"DESC_D_H_E2M7",
	"DESC_D_H_E2M8",
	"DESC_D_H_E2M9",
	"DESC_D_H_E3M2",
	"DESC_D_H_E3M3",
	"DESC_D_H_CPTD",
	"DESC_WINNOWR", // Hexen
	"DESC_JACHR",
	"DESC_SIMONR",
	"DESC_WUTZITR",
	"DESC_FALCONR",
	"DESC_LEVELR",
	"DESC_CRYPTR",
	"DESC_SWAMPR",
	"DESC_DEEPR",
	"DESC_FUBASR",
	"DESC_GROVER",
	"DESC_FORTR",
	"DESC_VOIDR",
	"DESC_CHAP_1R",
	"DESC_CHAP_2R",
	"DESC_CHAP_3R",
	"DESC_CHAP_4R",
	"DESC_SECRETR",
	"DESC_CHIPPYR",
	"DESC_PERCR",
	"DESC_FOOJAR",
	"DESC_SIXATER",
	"DESC_WOBABYR",
	"DESC_FANTAR",
	"DESC_BLECHR",
	"DESC_BONESR",
	"DESC_OCTOR",
	"DESC_RITHMR",
	"DESC_STALKR",
	"DESC_BORKR",
	"DESC_CRUCIBR",
	"DESC_CHARTR",
	"DESC_HUB",
	"DESC_HALL",
	"DESC_ORB",
	"DESC_CHESS",
	"DESC_CASA1", // Hexen 2
	"DESC_CASA2",
	"DESC_CASA3",
	"DESC_CASA4",
	"DESC_EGYP1",
	"DESC_EGYP2",
	"DESC_EGYP3",
	"DESC_MESO1",
	"DESC_MESO2",
	"DESC_MESO3",
	"DESC_ROMA1",
	"DESC_ROMA2",
	"DESC_ROMA3",
	"DESC_CASB1",
	"DESC_CASB2",
	"DESC_CASB3",
	"DESC_TULKU1", // Hexen 2 Expansion
	"DESC_TULKU2",
	"DESC_TULKU3",
	"DESC_TULKU4",
	"DESC_TULKU5",
	"DESC_TULKU6",
	"DESC_TULKU7",
	"DESC_TULKU8",
	"DESC_TULKU9",
	"DESC_TULKU10",
	"DESC_CCCOOL", // ROTT
	"DESC_CHANT",
	"DESC_EVINRUDE",
	"DESC_EXCALIBR",
	"DESC_FASTWAY",
	"DESC_GAZZ",
	"DESC_HELLERO",
	"DESC_HOWDIDO",
	"DESC_KISSOFF",
	"DESC_MEDIEV1A",
	"DESC_MISTACHE",
	"DESC_OWW",
	"DESC_RADAGIO",
	"DESC_RISE",
	"DESC_RUNLIKE",
	"DESC_SHARDS",
	"DESC_SMOKE",
	"DESC_SMOOTH",
	"DESC_SPRAY",
	"DESC_STAIRS",
	"DESC_SUCKTHIS",
	"DESC_TASKFORC",
	"DESC_WATZNEXT",
	"DESC_WHERIZIT",
	"DESC_WORK_DAY",
	"DESC_YOUSUCK",
	"DESC_D_C_E1M1", // Chex Quest
	"DESC_D_C_E1M2",
	"DESC_D_C_E1M3",
	"DESC_D_C_E1M4",
	"DESC_D_C_E1M5",
	"DESC_D_C_E2M1",
	"DESC_D_C_E2M2",
	"DESC_D_C_E2M3",
	"DESC_D_C_E2M4",
	"DESC_D_C_E2M5",
	"DESC_D_C_E3M1",
	"DESC_D_C_E3M2",
	"DESC_D_C_E3M3",
	"DESC_D_C_E3M4",
	"DESC_D_C_E3M5",
	"DESC_D_C_INTR",
	"DESC_D_C_VICT",
	"DESC_D_C_BUNN",
	"DESC_S_ACTION", // Strife
	"DESC_S_CASTLE",
	"DESC_S_DANGER",
	"DESC_S_DARK",
	"DESC_S_DARKER",
	"DESC_S_DRONE",
	"DESC_S_FAST",
	"DESC_S_FIGHT",
	"DESC_S_INSTRY",
	"DESC_S_MARCH",
	"DESC_S_MOOD",
	"DESC_S_PANTHR",
	"DESC_S_SAD",
	"DESC_S_SLIDE",
	"DESC_S_SPENSE",
	"DESC_S_STRIKE",
	"DESC_S_TECH",
	"DESC_S_TRIBAL",
	"DESC_S_MAP03"
};

Script 346 OPEN NET clientside
{
int i;
int randomhack;
int lastmus;

    if (GetCvar("norandommusic") == 0)
    {
        MusicRandomizerOn = 1;
        if (GetCvar("mus_runninginzdoom") == 1)
        {
            i = random(0, RANDOMMUS-1);
            SetMusic(RandMusList[i],0);
        }
        else
        // Zandronum is funny about this. Online, it generates the same random seed every
        // time, even though that's the opposite of what you'd expect from a random call.
        // I have to use a workaround to generate pseudo-random behavior.
        // But it's better than dealing with ZDoom's barely-functional slapshod netcode!
        {
            randomhack = defaultCVar("mus_cl_randomhack",   0);
            lastmus    = defaultCVar("mus_cl_lastmusic",    0) - 1;

            for (i = 0; i < randomhack; i++) { random(0, 1); }
            randomhack = random(0, 500);
            SaveCVar("mus_cl_randomhack", randomhack);

            do { i = random(0, RANDOMMUS-1); }
            while (i == lastmus);

            SetMusic(RandMusList[i], 0);
            SaveCVar("mus_cl_lastmusic", i + 1);
        }
        Delay(35);
        if (GetCvar("nomusicinfo") == 0)
        {
            MusicInfo = RandMusInfo[i];
            SetFont("SmallFont");
            hudmessage(l:MusicInfo; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
        }
    }
    else
    {
        MusicRandomizerOn = 0;
    }
}

script 347 OPEN clientside
{
    delay(1);
    if (GetCvar("mus_runninginzdoom") == 0) // No option to disable on ZDoom because I'm pretty sure the only way this'll
    {                                       // be happening is when you manually load it, ergo want to listen to it...
        if (!GetCvar("norandommusic"))
            { ConsoleCommand("set norandommusic 0");
              ConsoleCommand("archivecvar norandommusic"); }
        if (!GetCvar("nomusicinfo"))
            { ConsoleCommand("set nomusicinfo 0");
              ConsoleCommand("archivecvar nomusicinfo"); }
    }
}

script 348 (int musicshit) NET clientside
{
int i;
int randomhack;
int lastmus;

switch (musicshit)
{
  case 0:
    SetMusic("silence");
    LocalAmbientSound("music/shift",127);
    Delay(35);
    if (GetCvar("norandommusic") == 0)
    {
        MusicRandomizerOn = 1;
        if (GetCvar("mus_runninginzdoom") == 1)
        {
            i = random(0, RANDOMMUS-1);
            SetMusic(RandMusList[i],0);
        }
        else
        {
            randomhack = defaultCVar("mus_cl_randomhack",   0);
            lastmus    = defaultCVar("mus_cl_lastmusic",    0) - 1;

            for (i = 0; i < randomhack; i++) { random(0, 1); }
            randomhack = random(0, 500);
            SaveCVar("mus_cl_randomhack", randomhack);

            do { i = random(0, RANDOMMUS-1); }
            while (i == lastmus);

            SetMusic(RandMusList[i], 0);
            SaveCVar("mus_cl_lastmusic", i + 1);
        }
        if (GetCvar("nomusicinfo") == 0)
        {
            MusicInfo = RandMusInfo[i];
            SetFont("SmallFont");
            hudmessage(l:MusicInfo; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
        }
    }
    else
    {
        MusicRandomizerOn = 0;
        SetMusic("*",0);
    }
    break;

  case 1:
    SetMusic("silence");
    LocalAmbientSound("music/shift",127);
    Delay(35);
    SetMusic("*",0);
    break;
}
}